#property copyright "Copyright  2013, Langouste"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
//---- input parameters
extern int AtrPeriod=14;
//---- buffers
double AtrBuffer[];
double TempBuffer1[];
double TempBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(3);
//---- indicator line
   SetIndexStyle (0,DRAW_LINE);
   SetIndexBuffer(0,AtrBuffer);
   SetIndexBuffer(1,TempBuffer1);
   SetIndexBuffer(2,TempBuffer2);
//---- name for DataWindow and indicator subwindow label
   short_name="ATR Normalize("+AtrPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,AtrPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=AtrPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=AtrPeriod;i++) AtrBuffer[Bars-i]=0.0;
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      double _Close =Close[i];
      double _Low = Low [i];      
      TempBuffer1[i]=_Close - _Low;
      //------------------------------------------------------------
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) TempBuffer2[i]=high-low;
      else
        {
         double prevclose=Close[i+1];
         TempBuffer2[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
        }
      //--------------------------------------------------------------  
      i--;
     }
//----
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   for(i=0; i<limit; i++)
      {
       if (iMAOnArray(TempBuffer2,Bars,AtrPeriod,0,MODE_SMA,i)!=0)
       AtrBuffer[i] = (iMAOnArray(TempBuffer1,Bars,AtrPeriod,0,MODE_SMA,i)/iMAOnArray(TempBuffer2,Bars,AtrPeriod,0,MODE_SMA,i))*100;
      } 
//----
   return(0);
  }
//+------------------------------------------------------------------+